function [delta,flows] = check_max_flow(adjmat,x)
  n = length(adjmat);
  nedges = nnz(adjmat);

  incidents = [];
  flows = zeros(2,n);

  nedges_sofar = 0;
  for src = 1:size(adjmat,1)
    for dst = 1:size(adjmat,2)
      weight = adjmat(src,dst);
      if (weight == 0)
        continue;
      end
      nedges_sofar = nedges_sofar + 1;
      incidents(:,nedges_sofar) = [src;dst];
      flows(1,src) = flows(1,src) + x(nedges_sofar);
      flows(2,dst) = flows(2,dst) + x(nedges_sofar);
    end
  end

  delta = flows(2,:) - flows(1,:);
end

