#!/usr/bin/perl

@statevars = qw(KOP PG SI SS PS);

@actions = qw(BPG BSI BSS BPS MNKOP MKOP MNPG MPG MNSI MSI MNSS MSS MNPS MPS);

while ($line = <>) {
  chomp($line);
  if ($line =~ /^v (.+)$/) {
    $soltxt = $line;
  }
}

@solvals = split(' ', $soltxt);

foreach $solval (sort { abs($a) <=> abs($b) } @solvals) {
  next if ($solval == 0);
  $var = abs($solval);
  if ($var <= 20) {
    $name = $statevars[($var-1)%5];
    $stage = int(($var-1)/5);
  }
  else {
    $name = $actions[($var-21)%14];
    $stage = 1+2*int(($var-21)/14);
  }
  print "" . ($solval < 0 ? "!" : "") . $name . $stage . "\n";
}

